﻿<?php
ini_set('memory_limit', '512M');
include('header.php');
print"<table align=\"center\"><td align=\"center\"><h2>Solution of Partial Differential Equations</h2></td><tr><td>";
print"This script gives the numirical solution of PDE of the form <br><b>a1*Uxx+a2*Uyy+a3*Ux+a4*Uy+a6*U=f(x,y)</b></td></tr></table>";
if(isset($_POST['submit'])){
$time_start = microtime(true);
include('library.php');
$eq="Uxx+"."+Uyy"."=".$_POST['fun'];
$ttle='solution of PDE  '.$eq;

$n=$_POST['n'];
$y0=$_POST['y0'];
$yn=$_POST['yn'];
$x0=$_POST['x0'];
$xn=$_POST['xn'];
$h=($xn-$x0)/$n;
$bx0=$_POST['ux0'];
$bxn=$_POST['uxn'];
$by0=$_POST['uy0'];
$byn=$_POST['uyn'];
$H=pow($h,2);
$m=$n*($yn-$y0)/($xn-$x0);
$output=$_POST['output'];
$n1=$n-1;
$m1=$m-1;


//========================================
for($l=0;$l<=3000;$l++){
for($i=0;$i<=$n;$i++){
for($j=0;$j<=$m;$j++){
$u[$i][$j][$l]=1;
}}}

for($l=0;$l<=3000;$l++){
for($i=0;$i<=$n;$i++){
for($j=0;$j<=$m;$j++){
$u[$i][$m][$l]=$byn;
$u[$n][$j][$l]=$bxn;
$u[0][$j][$l]=$bx0;
$u[$i][0][$l]=$by0;
}}}
for($i=0;$i<=$n;$i++){
for($j=0;$j<=$m;$j++){

$x[$i]=$x0+$h*$i;
$y[$j]=$y0+$h*$j;
}
}

print"<table>";
$l=1;
$c=100;
a:
$i=1;
while($i<=$n1){
$j=1;
while($j<=$m1){
$D1=2*(a1($x[$i],$y[$j])+a2($x[$i],$y[$j]))-$H*a6($x[$i],$y[$j]);
$D2=a1($x[$i],$y[$j])+$h*a4($x[$i],$y[$j])/2;
$D3=a1($x[$i],$y[$j])-$h*a4($x[$i],$y[$j])/2;
$D4=a2($x[$i],$y[$j])+$h*a5($x[$i],$y[$j])/2;
$D5=a2($x[$i],$y[$j])-$h*a5($x[$i],$y[$j])/2;
$g=f($x[$i],$y[$j]);
if($g==0){
$g=pow(10,-99);
}
$D7=($u[$i-1][$j+1][$l+1]+$u[$i+1][$j-1][$l+1]-$u[$i+1][$j+1][$l]-$u[$i-1][$j-1][$l])/4;
$u[$i][$j][$l+1]=($D2*$u[$i+1][$j][$l]+$D3*$u[$i-1][$j][$l+1]+$D4*$u[$i][$j+1][$l]+$D5*$u[$i][$j-1][$l+1]+$D7*a3($x[$i],$y[$j])-$H*$g)/$D1;
$c=abs($u[$i][$j][$l+1]-$u[$i][$j][$l]);
//print $u[$i][$j][$l+1]."<br>";
if($c<=pow(10,-15)||$l>2999){goto b;}

$j++;
}
$i++;
}
$l++;
goto a;
b:
//exit;
//====================================================================
for($i=0;$i<=$n;$i++){
for($j=0;$j<=$m;$j++){
$uu[$j][$i]=$u[$i][$j][$l];
}}
//=======================================================================
if($output=='numbers'){
for($j=1;$j<$m;$j++){
print"<tr><td>X(".$j.")=".$x[$j]."</td></tr>";
for($i=1;$i<$n;$i++){

print "<tr><td>".$x[$i]."</td><td>".$uu[$j][$i]."</td></tr>";
}
}
print"</table>";
 $time_end = microtime(true);
     $totaltime = $time_end - $time_start;
      print"<table align=\"center\"><td>This calculation was carried in " .$totaltime. " seconds."."</td></table>";

}
//================================================================
if($output=='graph'){
for($i=0;$i<=$n;$i++){
for($j=0;$j<=$m;$j++){
$uu[$j][$i]=$u[$i][$j][$l];
}}

//============================================Graph======================
$file=data($uu,$x,$n,$m);
$yax='U(x,y)';
print"<table><td>";
include('grf.php');
print"</td><td><table>";
for($j=1;$j<$m;$j++){
print"<tr><td>X(".$j.")=".$x[$j]."</td></tr>";
for($i=1;$i<$n;$i++){

print "<tr><td>".$x[$i]."</td><td>".$uu[$j][$i]."</td></tr>";
}
}
print"</table>";
$time_end = microtime(true);
     $totaltime = $time_end - $time_start;
      print"<table align=\"center\"><td>This calculation was carried in " .$totaltime. " seconds."."</td></table>";
print"</td></table>";
}

exit;
}
//=================================================================================
print"<form method=\"POST\"action=\"\"><br>";
print"<b>No of intervals =</b><input type=\"text\"name=\"n\"style=\"width:50px\"><br>";
print"<b>Coefficient of Uxx a1(X,Y)=</b><input type=\"text\" name=\"a1\"style=\"width:50px\"><br>";
print"<b>Coefficient of Uyy a2(X,Y)=</b><input type=\"text\" name=\"a2\"style=\"width:50px\"><br>";
print"<b>Coefficient of Uxy a3(X,Y)=</b><input type=\"text\" name=\"a3\"style=\"width:50px\"><br>";
print"<b>Coefficient of Ux a4(X,Y)=</b><input type=\"text\" name=\"a4\"style=\"width:50px\"><br>";
print"<b>Coefficient of Uy a5(X,Y)=</b><input type=\"text\" name=\"a5\"style=\"width:50px\"><br>";
print"<b>Coefficient of U a6(X,Y)=</b><input type=\"text\" name=\"a6\"style=\"width:50px\"><br>";
print"<b>the RHS f(x,y)=</b><input type=\"text\" name=\"fun\"style=\"width:200px\"><br>";
print"<b>u(X0,Y)=</b><input type=\"text\" name=\"ux0\"style=\"width:50px\"><br>";
print"<b>u(Xn,Y)=</b><input type=\"text\" name=\"uxn\"style=\"width:50px\"><br>";
print"<b>u(X,Y0)=</b><input type=\"text\" name=\"uy0\"style=\"width:50px\"><br>";
print"<b>u(X,Yn)=</b><input type=\"text\" name=\"uyn\"style=\"width:50px\"><br>";
print"<b>Lower X0=</b><input type=\"text\" name=\"x0\"style=\"width:50px\"><b>Lower Y0 = </b><input type=\"text\" name=\"y0\"><br>";
print"<b>Upper Xn=</b><input type=\"text\" name=\"xn\"style=\"width:50px\"><b>Upper Yn =</b><input type=\"text\" name=\"yn\"><br>";
print"<b>Output format :</b><select name=\"output\">";
print"<option value\"\">Select outpout format</option>";
print"<option value=\"graph\">Graph</option>";
print"<option value=\"numbers\">Numbers</option>";
print"</select>";
print"<input type=\"submit\" name=\"submit\"value=\"submit\"></form>";
?>
