﻿<?php
include('header.php');
print"<table align=\"center\"><td align=\"center\"><h2>Solution of ODE</h2></td><tr><td>";
print"This script gives the numirical solution of ordinary differential equations of second order in the form<br>A Y''(x)+B Y'(x)+C Y(x)= f(x)<br> by LU factorization where A, B and C are constants</td></table>";
if(isset($_POST['submit'])){
$time_start = microtime(true);
include('library.php');
$n=$_POST['n'];
$y0=$_POST['y0'];
$yn=$_POST['yn'];
$a=$_POST['a'];
$bb=$_POST['b'];
$c=$_POST['c'];
$x0=$_POST['x0'];
$xn=$_POST['xn'];
$output=$_POST['output'];
$ttle='Solution of ODE';
$m=$n-1;
$h=($xn-$x0)/$n;
$H=pow($h,2);
$D1=(4*$a-2*$c*$h*$h);
$D2=2*$a+$bb*$h;
$D3=2*$a-$bb*$h;
for($i=0;$i<=$n;$i++){
$x[$i]=$x0+$i*$h;
$y[$i]=0;
}

for($i=0;$i<=$n;$i++){
$f1[$i]=-2*$H*f($x[$i]);
}
$f1[1]=$f1[1]+$D2*$y[0];
$f1[$m]=$f1[$m]+$D3*$y[$n];
for($i=1;$i<=$m;$i++){
for($j=1;$j<=$m;$j++){
if($j == $i){$A[$i][$j] =$D1;}
elseif($j ==$i + 1){ $A[$i][$i + 1] = -$D2;}
elseif($j ==$i - 1){$A[$i][$i - 1] = -$D3;}
else{$A[$i][$j]=0;}
}}
//==========================


list($L,$U)=lu($A,$m);

$y=sol($L,$U,$f1,$m);

$y[0]=0;
$y[$n]=0;

//====================================Output Numbers======================================================
if($output=='numbers'){
print"<table align=\"center\"><td width=\"100\">X</td><td width=\"100\">Y</td>";
for($j=0;$j<=$n;$j++){

print"<tr><td>". $x[$j]."</td><td>".$y[$j]."</td></tr>";
}
print"</table>";
 $time_end = microtime(true);
     $totaltime = $time_end - $time_start;
      print"<table align=\"center\"><td>This calculation was created in " .$totaltime. " seconds."."</td></table>";
}
//====================================outpout Graph=========================================
if($output=='graph'){
$y[0]=$y0;
$y[$n]=$yn;
$yax='U(x)';
$file=datao($y,$x,$n);
print"<table><td>";

include('grf.php');
print"</td><td>";
print"<table align=\"center\"><td width=\"100\">X</td><td width=\"100\">U</td>";
for($j=0;$j<=$n;$j++){

print"<tr><td>". $x[$j]."</td><td>".$y[$j]."</td></tr>";
}
print"</table>";
 $time_end = microtime(true);
     $totaltime = $time_end - $time_start;
      print"<table align=\"center\"><td>This calculation was carried in " .$totaltime. " seconds."."</td></table>";
print"</td></table>";
}
 
//==================================================================
exit;
}
print"<form method=\"post\"action=\"\"><br>";
print"<b>No of intervals =</b><input type=\"text\"name=\"n\"style=\"width:50px\"><br>";

print"<b>the coefficient A=</b><input type=\"text\" name=\"a\"style=\"width:50px\"><br>";
print"<b>the coefficient B=</b><input type=\"text\" name=\"b\"style=\"width:50px\"><br>";
print"<b>the coefficient C=</b><input type=\"text\" name=\"c\"style=\"width:50px\"><br>";
print"<b>the RHS f(x)=</b><input type=\"text\" name=\"fun\"style=\"width:200px\"><br>";
print"<b>Lower limit X0=</b><input type=\"text\" name=\"x0\"style=\"width:50px\"><b>Its boundary Y0 = </b><input type=\"text\" name=\"y0\"><br>";
print"<b>Upper limit Xn=</b><input type=\"text\" name=\"xn\"style=\"width:50px\"><b>Its boundary Yn =</b><input type=\"text\" name=\"yn\"><br>";
print"<b>Output format :</b><select name=\"output\">";
print"<option value\"\">Select outpout format</option>";
print"<option value=\"graph\">Graph</option>";
print"<option value=\"numbers\">Numbers</option>";
print"</select>";
print"<input type=\"submit\" name=\"submit\"value=\"submit\"></form>";
?>
