﻿<?php
ini_set('memory_limit', '512M');
include('header.php');
print"<table align=\"center\"width=\"80%\"><td align=\"center\"><h2>Solution of Partial Differential Equations</h2></td><tr><td>";
print"This script gives the numirical solution of Laplace and Poisson equation <br>Δ u(x,y)=f(x,y) where f(x,y)=0 for Laplace equation<br> by LU factorization </td></table>";
if(isset($_POST['submit'])){
$time_start = microtime(true);
include('library.php');
$n=$_POST['n'];
$y0=$_POST['y0'];
$yn=$_POST['yn'];
$x0=$_POST['x0'];
$xn=$_POST['xn'];
$h=($xn-$x0)/$n;
$bx0=$_POST['ux0'];
$bxn=$_POST['uxn'];
$by0=$_POST['uy0'];
$byn=$_POST['uyn'];
$output=$_POST['output'];
$m=ceil($n*($yn-$y0)/($xn-$x0));
$n1=$n-1;
$m1=$m-1;
$nm=$m*$n;
$l=$m1*$n1;

//=============================================
$A=Btridiag($n,$m,$n1,$m1,$l,$nm);
//=============================

$eq="Uxx+"."+Uyy"."=".$_POST['fun'];
$ttle='solution of PDE  '.$eq;
//print $eq;
//exit;
//============================================f(x,y)=========================
for($i=0;$i<=$n;$i++){
$x[$i]=$x0+$i*$h;
}
for($i=0;$i<=$m;$i++){

$y[$i]=$y0+$i*$h;
}
for($i=0;$i<=$n;$i++){
for($j=0;$j<=$m;$j++){

$uu[$i][$j]=0;
$uu[$j][$i]=0;
}}
//======================BC============
for($i=0;$i<=$n;$i++){

for($j=0;$j<=$m;$j++){

$uu[0][$j]=$bx0;

$uu[$n][$j]=$bxn;
$uu[$i][0]=$by0;
$uu[$i][$n]=$byn;
}}

$p=1;

for($j=1;$j<=$m1;$j++){
for($i=1;$i<=$n1;$i++){
$g=f($x[$i],$y[$j]);
$f1[$p]=$uu[$i+1][$j]+$uu[$i-1][$j]+$uu[$i][$j+1]+$uu[$i][$j-1]-$h*$h*$g;
$p++;
}
}
//exit;
//===========================================================================
list($L,$U)=lu($A,$l);
$F=sol($L,$U,$f1,$l);
$F[0]=0;
$F[$nm]=0;
$p=1;
for($i=1;$i<$m;$i++){
for($j=1;$j<$n;$j++){
$uu[$j][$i]=$F[$p];
$p++;
}
}
//=============================output Numbers===========================================
if($output=='numbers'){
print"<table align=\"center\"><td>Y</td><td> U </td>";
$p=1;

for($j=1;$j<$m;$j++){
print"<tr><td>Y(".$j.")=".$y[$j]."</td></tr>";

 for($i=1;$i<$n;$i++){
print "<tr><td>".$x[$i]."</td><td>".$uu[$i][$j]."</td></tr>";
}
}
//======================================================================

print"</table>";
 $time_end = microtime(true);
     $totaltime = $time_end - $time_start;
      print"<table align=\"center\"><td>This calculation was carried in " .$totaltime. " seconds."."</td></table>";
}

//===========================================output Graph======================
if($output=='graph'){
$yax='U(x,y)';
for($i=0;$i<=$m;$i++){
for($j=0;$j<=$n;$j++){
$uug[$i][$j]=$uu[$j][$i];
}}
$uug[$n][$m]=0;
$uug[$m][$n];
Print"<table><td>";
$file=data($uug,$x,$n,$m);
include('grf.php');
print"</td><td>";
Print"<table>";
 for($i=1;$i<$m;$i++){
print"<tr><td>Y(".$i.")=".$y[$i]."</td></tr>";

for($j=0;$j<=$n;$j++){
print "<tr><td>".$x[$j]."</td><td>".$uug[$i][$j]."</td></tr>";
}

}
print"</table>";
$time_end = microtime(true);
     $totaltime = $time_end - $time_start;
      print"<table align=\"center\"><td>This calculation was carried in " .$totaltime. " seconds."."</td></table>";

print"</td></table>";

//======================================LU===================
}
exit;
}
print"<table align=\"center\"width=\"60%\">";
print"<form method=\"post\"action=\"\"align=\"center\"><td><br>";
print"<b>No of intervals =</b><input type=\"text\"name=\"n\"style=\"width:50px\"><br>";

print"<b>u(X0,Y)=</b><input type=\"text\" name=\"ux0\"style=\"width:50px\"><br>";
print"<b>u(Xn,Y)=</b><input type=\"text\" name=\"uxn\"style=\"width:50px\"><br>";
print"<b>u(X,Y0)=</b><input type=\"text\" name=\"uy0\"style=\"width:50px\"><br>";
print"<b>u(X,Yn)=</b><input type=\"text\" name=\"uyn\"style=\"width:50px\"><br>";
print"<b>the RHS f(x,y)=</b><input type=\"text\" name=\"fun\"style=\"width:200px\"><br>";
print"<b>Lower X0=</b><input type=\"text\" name=\"x0\"style=\"width:50px\"><b>Lower Y0 = </b><input type=\"text\" name=\"y0\"><br>";
print"<b>Upper Xn=</b><input type=\"text\" name=\"xn\"style=\"width:50px\"><b>Upper Yn =</b><input type=\"text\" name=\"yn\"><br>";
print"<b>Output format :</b><select name=\"output\">";
print"<option value\"\">Select outpout format</option>";
print"<option value=\"graph\">Graph</option>";
print"<option value=\"numbers\">Numbers</option>";
print"</select>";
print"<input type=\"submit\" name=\"submit\"value=\"submit\"></td></form>";
print"</table>"
?>
